; This is TP02.asm for Q2 of EE3046Spring2022 final exam.
; In this program, DJNZ should be changed to JZR to be run in our 8051 CPU circuit.
; Purpose of TP02.asm = to check the functionality of the microinstruction of new instruction JZR. 
; How to check: If JZR microinstruction works correctly, this program will end at LB10. 
;                     Otherwise, it may end at LB09 or stall at somewhere else.
	NOP
LB01:
	MOV	R3, #LB02
	MOV	A,#0H
	DJNZ	R3,6H ; Should jump to LB03
	JMP	LB09
	ORG	20H
LB02:
	NOP
	NOP
	NOP
	NOP
	JMP	LB09
LB03:
	MOV	R3,#LB05
	MOV	A,#0H
	DJNZ	R3,0F2H  ; Should jump to LB04
	SJMP	LB09

ORG	40H
	JMP	LB09
LB04:
	MOV	R3,#LB09
	MOV	A,#55H
	DJNZ	R3,2H  ; Should not jump.
	JMP	LB10
ORG	50H
LB05:
	JMP	LB09

; The execution may end up jumping to LB09 if any branch is incorrect.
LB09:
	MOV	R7,#0FFH
	JMP	LB09
; The execution will eventually reach LB10 if all branches are correct.
ORG	60H
LB10:
	MOV	R7,#77H
	JMP	LB10
